'AutoPasteLoop.bas, version 1.0
'Visit: www.pdfhacks.com/autopaste/
'
'Start AutoPasteLoop from MS Word and switch to Adobe Reader or Acrobat.
'Copy the material you want, and AutoPasteLoop will automatically
'paste it into the target Word document.  When you are done, switch back
'to MS Word and AutoPasteLoop will stop.

Option Explicit

' declare Win32 API functions that we need
Declare Function Sleep Lib "kernel32" (ByVal insdf As Long) As Long
Declare Function GetForegroundWindow Lib "user32" () As Long
Declare Function GetOpenClipboardWindow Lib "user32" () As Long
Declare Function GetClipboardOwner Lib "user32" () As Long

Sub AutoPasteLoop()
    'the HWND of the application we're pasting into (MS Word)
    Dim AppHwnd As Long
    'assume that we are executed from the target app.
    AppHwnd = GetForegroundWindow()
    
    'keep track of whether the user switches out
    'of the target application (MS Word).
    Dim SwitchedApp As Boolean
    SwitchedApp = False
    
    'reset this to stop looping
    Dim KeepLooping As Boolean
    KeepLooping = True
    
    'the HWND of our target document; GetClipboardOwner returns the
    'HWND of the app. that most recently owned the clipboard;
    'changing the clipboard's contents (Cut) makes us the "owner"
    'note that "owning" the clipboard doesn't mean that it's locked
    '
    Dim DocHwnd As Long
    Selection.TypeText Text:="abc"
    Selection.MoveLeft Unit:=wdCharacter, Count:=3, Extend:=wdExtend
    Selection.Cut
    DocHwnd = GetClipboardOwner()
    
    Do While KeepLooping
        Sleep 200 'milliseconds; 100 msec == 1/10 sec
        
        'if the user switches away from the target
        'application and then switches back, stop looping
        '
        Dim ActiveHwnd As Long
        ActiveHwnd = GetForegroundWindow()
        If ActiveHwnd = AppHwnd Then
            If SwitchedApp Then KeepLooping = False
        Else
            SwitchedApp = True
        End If
    
        'if the clipboard owner has changed, then somebody else
        'has put something on it; if the clipboard resource isn't
        'locked (GetOpenClipboardWindow), then paste its contents
        'into our document; use Copy to change the clipboard owner
        'back to DocHwnd
        '
        If GetClipboardOwner() <> DocHwnd And _
        GetOpenClipboardWindow() = 0 Then
            Selection.Paste
            Selection.MoveLeft Unit:=wdCharacter, Count:=1, Extend:=wdExtend
            Selection.Copy
            Selection.Collapse wdCollapseEnd
        End If
    Loop
End Sub