Sub SummarizeComments()
' version 1.0
' www.pdfhacks.com/summarize/
'
Dim app As Object
Set app = CreateObject("AcroExch.App")
If (0 < app.GetNumAVDocs) Then
  ' a PDF is open in Acrobat
  ' create a new Word doc to hold the summary
  Dim NewDoc As Document
  Dim NewDocRange As Range
  Set NewDoc = Documents.Add(DocumentType:=wdNewBlankDocument)
  Set NewDocRange = NewDoc.Range
  
  Dim found_notes_b As Boolean
  found_notes_b = False
  
  ' get the active doc and drill down to its PDDoc
  Dim avdoc, pddoc As Object
  Set avdoc = app.GetActiveDoc
  Set pddoc = avdoc.GetPDDoc
  
  ' iterate over pages
  Dim num_pages As Long
  num_pages = pddoc.GetNumPages
  For ii = 0 To num_pages - 1
    
    Dim pdpage As Object
    Set pdpage = pddoc.AcquirePage(ii)
    If (Not pdpage Is Nothing) Then
      
      ' iterate over annotations (e.g., sticky notes)
      Dim page_head_b As Boolean
      page_head_b = False
      Dim num_annots As Long
      num_annots = pdpage.GetNumAnnots
      For jj = 0 To num_annots - 1
        
        Dim annot As Object
        Set annot = pdpage.GetAnnot(jj)
        ' Popup annots give us duplicate contents
        If (annot.GetContents <> "" And _
            annot.GetSubtype <> "Popup") Then
          
          If (page_head_b = False) Then ' output the page number
            NewDocRange.Collapse wdCollapseEnd
            NewDocRange.Text = "Page: " & (ii + 1) & vbCr
            NewDocRange.Bold = True
            NewDocRange.ParagraphFormat.LineUnitBefore = 1
            page_head_b = True
          End If
          
          ' output the annotation title and format it a little
          NewDocRange.Collapse wdCollapseEnd
          NewDocRange.Text = annot.GetTitle & vbCr
          NewDocRange.Italic = True
          NewDocRange.Font.Size = NewDocRange.Font.Size - 1
          NewDocRange.ParagraphFormat.LineUnitBefore = 0.6
          
          ' output the note text and format it a little
          NewDocRange.Collapse wdCollapseEnd
          NewDocRange.Text = annot.GetContents & vbCr
          NewDocRange.Font.Size = NewDocRange.Font.Size - 2
          
          found_notes_b = True
        End If
      Next jj
    End If
  Next ii
  
  If (Not found_notes_b) Then
    NewDocRange.Collapse wdCollapseEnd
    NewDocRange.Text = "No Notes Found in PDF" & vbCr
    NewDocRange.Bold = True
  End If
End If
End Sub
