// page_turner.js, version 1.0
// visit: www.pdfhacks.com/page_turner/

var pt_wait= 3000; // three seconds; set to taste
var pt_step= 1000; // adjust speed in steps of one second
var pt_timeout= 0;
var pt_our_doc= 0;
var pt_our_path= 0;

function PT_Stop() {
  if( pt_timeout!= 0 ) {
    // stop turning pages
    app.clearInterval( pt_timeout );

    pt_timeout= 0;
    pt_our_doc= 0;
    pt_our_path= 0;
  }
}

function PT_TurnPage() {
  if( this!= pt_our_doc ||
      this.path!= pt_our_path )
  { // Acrobat's state has changed; stop turning pages
    PT_Stop();
  }
  else if( 0< this.pageNum &&
           this.pageNum== this.numPages- 1 )
  {
    app.execMenuItem("FirstPage"); // return to the beginning
  }
  else {
    // this works better than this.pageNum++ when
    // using 'continuous facing pages' viewing mode
    app.execMenuItem("NextPage");
  }
}

function PT_Start( wait ) {
  if( pt_timeout== 0 ) {
    // start turning pages
    pt_our_path= this.path;
    pt_our_doc= this;
    pt_timeout= app.setInterval( 'PT_TurnPage()', wait );
  }
}

////
// add menu items to the Acrobat/Reader View menu

app.addMenuItem( {
cName: "-",              // menu divider
cParent: "View",         // append to the View menu
cExec: "void(0);" 
} );

app.addMenuItem( {
cName: "Start Page Turner &4",
cParent: "View",
cExec: "PT_Start( pt_wait );",
//
// "event" is an object passed to us upon execution;
// in this context, event.target is the currently active document;
// event.rc is the return code: success <==> show menu item
cEnable: "event.rc= ( event.target!= null && pt_timeout== 0 );"
} );

app.addMenuItem( {
cName: "Slower",
cParent: "View",
cExec: "PT_Stop(); pt_wait+= pt_step; PT_Start( pt_wait );",
cEnable: "event.rc= ( event.target!= null && pt_timeout!= 0 );"
} );

app.addMenuItem( {
cName: "Faster",
cParent: "View",
cExec: "if(pt_step< pt_wait) { PT_Stop(); pt_wait-= pt_step; PT_Start(pt_wait); }",
cEnable: "event.rc= (event.target != null && pt_timeout!= 0 && pt_step< pt_wait);"
} );

app.addMenuItem( {
cName: "Stop Page Turner",
cParent: "View",
cExec: "PT_Stop();",
cEnable: "event.rc= ( event.target != null && pt_timeout!= 0 );"
} );