<?php
// serve_newsletter.php, version 1.0

$fp= @fopen( "./newsletter.{$_GET['edition']}.pdfsrc", 'r' );
if( $fp ) {

  if( $_GET['debug'] ) {
    header("Content-Type: text/plain"); // debug
  }
  else {
    header('Content-Type: application/pdf');
  }

  $pdf_offset= 0;
  $url_offsets= array();

  // iterate over first lines of pdfsrc file to load $url_offsets
  while( $cc= fgets($fp, 1024) ) {
    if( $cc{0}== '#' ) { // one of our comments
      list($comment, $name, $offset)= explode( '-', $cc );

      if( $name== 'userhome' ) {
	$url_offsets[(int)$offset]= 
	  'http://www.pdfhacks.com/user_home.php?user=' . $_GET['user'];
      }
      else if( $name== 'newsletters' ) {
	$url_offsets[(int)$offset]= 
	  'http://www.pdfhacks.com/newsletter_home.php?user=' . $_GET['user'] . 
	  '&edition=' . $_GET['edition'];
      }
      else { // default
	$url_offsets[(int)$offset]= 'http://www.pdfhacks.com';
      }
    }
    else { // finished with our comments
      echo $cc;
      $pdf_offset= strlen($cc)+ 1;

      break;
    }
  }

  // sort by increasing offsets
  ksort( $url_offsets, SORT_NUMERIC );
  reset( $url_offsets );

  $output_url_line_b= false;
  $output_url_b= false;
  $closed_string_b= false;

  list( $offset, $url )= each( $url_offsets );
  $url_ii= 0;
  $url_len= strlen($url);

  // iterate over rest of file
  while( ($cc= fgetc($fp))!= "" ) {

    if( $output_url_line_b && $cc== '(' ) {
      // we have reached the beginning of our URL
      $output_url_line_b= false;
      $output_url_b= true;

      echo '(';
    }
    else if( $output_url_b ) {
      if( $cc== ')' ) { // finished with this URL
	if( $closed_string_b ) {
	  // string has already been capped; pad
	  echo ' ';
	}
	else {
	  echo ')';
	}

	// get next offset/URL pair
	list( $offset, $url )= each( $url_offsets );
	$url_ii= 0;
	$url_len= strlen($url);

	// reset
	$output_url_b= false;
	$closed_string_b= false;
      }
      else if( $url_ii< $url_len ) {
	// output one character of $url
	echo $url{$url_ii++};
      }
      else if( $url_ii== $url_len ) {
	// done with $url, so cap this string
	echo ')';
	$closed_string_b= true;
	$url_ii++;
      }
      else {
	echo ' '; // replace padding with space
      }
    }
    else {
      // output this character
      echo $cc;

      if( $offset== $pdf_offset ) {
	// we have reached a line in pdfsrc where
	// our URL should be; begin a lookout for '('
	$output_url_line_b= true;
      }
    }

    ++$pdf_offset;
  }

  fclose( $fp );
}
else { // file open failure
  echo 'Error: failed to open: '."./newsletter.{$_GET['edition']}.pdfsrc";
}
?>